unit UMain;

interface

{$I JEDI.INC}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Grids, MPlayer, MMSystem,
  SSVolumeController,
  UTInfoTrackTh, jpeg,
{$IFDEF DELPHIXE5_UP}
  Vcl.ActnList, Vcl.ImgList, Vcl.Buttons,  System.Actions,
  IPPeerClient,
  IPPeerServer, System.Tether.Manager, System.Tether.AppProfile
{$ELSE}
  ActnList, Buttons, DBCtrls, Mask, IPPeerClient, IPPeerServer,
  System.Tether.Manager, System.Tether.AppProfile, Vcl.ImgList, System.Actions,
  Vcl.Imaging.pngimage, System.Bluetooth, System.Bluetooth.Components
{$ENDIF}
 ;


const
  MAX_VOL_GENERIC = 100;


type

  TStringGrid = class(Grids.TStringGrid)
  private
    FGraphic: TGraphic;
    FStretched: Boolean;
    function BackgroundVisible(var ClipRect: TRect): Boolean;
    procedure PaintBackground;
  protected
    procedure Paint; override;
    procedure Resize; override;
    procedure TopLeftChanged; override;
  public
    property BackgroundGraphic: TGraphic read FGraphic write FGraphic;
    property BackgroundStretched: Boolean read FStretched write FStretched;
  end;


  TFormMain = class(TForm)
    Panel1: TPanel;
    PageControl1: TPageControl;
    tsReproductor: TTabSheet;
    tsLog: TTabSheet;
    ProgresTimer: TTimer;
    mmLog: TMemo;
    ActionList1: TActionList;
    ActionPlay: TAction;
    ActionPause: TAction;
    ActionStop: TAction;
    ActionAdelante: TAction;
    Actionatras: TAction;
    ImageList1: TImageList;
    pnlInfo: TPanel;
    Panel3: TPanel;
    Label3: TLabel;
    sgCanciones: TStringGrid;
    Panel2: TPanel;
    Panel4: TPanel;
    sbPlay: TSpeedButton;
    sbPause: TSpeedButton;
    sbStop: TSpeedButton;
    sbAdelante: TSpeedButton;
    sbAtras: TSpeedButton;
    lblPosition: TLabel;
    lblDuracion: TLabel;
    lblVolumen: TLabel;
    tbVolumen: TTrackBar;
    tbCancion: TTrackBar;
    imgBack: TImage;
    pnlCamposInfo: TPanel;
    Label2: TLabel;
    dbedtArtista: TEdit;
    dbedtAlbum: TEdit;
    Label4: TLabel;
    dbimgCaratula: TImage;
    dbedtCancion: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    dbedtGenero: TEdit;
    Label7: TLabel;
    dbedtAnyo: TEdit;
    TimerPack: TTimer;
    lblReproduciendo: TLabel;
    TimerMarquee: TTimer;
    Panel5: TPanel;
    PaintFrame: TPaintBox;
    ttManager: TTetheringManager;
    ttProfiler: TTetheringAppProfile;
    ActionSendInfoToRemote: TAction;
    Panel6: TPanel;
    Shape2: TShape;
    Shape3: TShape;
    Shape1: TShape;
    imgWifi20: TImage;
    imgBlutooth20: TImage;
    sbMandoConectado: TSpeedButton;
    imgcontrolBlanco: TImage;
    imgControlAzul: TImage;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sgCancionesDblClick(Sender: TObject);
    procedure ProgresTimerTimer(Sender: TObject);
    procedure tbVolumenChange(Sender: TObject);
    //procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ActionPlayExecute(Sender: TObject);
    procedure ActionPauseExecute(Sender: TObject);
    procedure ActionStopExecute(Sender: TObject);
    procedure ActionAdelanteExecute(Sender: TObject);
    procedure ActionAtrasExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TimerPackTimer(Sender: TObject);
    procedure TimerMarqueeTimer(Sender: TObject);
    procedure tbCancionChange(Sender: TObject);
    procedure ttManagerPairedFromLocal(const Sender: TObject;
      const AManagerInfo: TTetheringManagerInfo);
    procedure ttManagerPairedToRemote(const Sender: TObject;
      const AManagerInfo: TTetheringManagerInfo);
    procedure ttProfilerAcceptResource(const Sender: TObject;
      const AProfileId: string; const AResource: TCustomRemoteItem;
      var AcceptResource: Boolean);
    procedure ttProfilerResourceUpdated(const Sender: TObject;
      const AResource: TRemoteResource);
    procedure ttManagerNewManager(const Sender: TObject;
      const AManagerInfo: TTetheringManagerInfo);
    procedure ttProfilerResourceReceived(const Sender: TObject;
      const AResource: TRemoteResource);
    procedure ActionSendInfoToRemoteExecute(Sender: TObject);
    procedure ttManagerEndAutoConnect(Sender: TObject);
    procedure ttManagerEndManagersDiscovery(const Sender: TObject;
      const ARemoteManagers: TTetheringManagerInfoList);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Shape2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape3ContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ttManagerEndProfilesDiscovery(const Sender: TObject;
      const ARemoteProfiles: TTetheringProfileInfoList);
    procedure sbTipoConexionClick(Sender: TObject);
    procedure ttManagerUnPairManager(const Sender: TObject;
      const AManagerInfo: TTetheringManagerInfo);
    procedure ttProfilerDisconnect(const Sender: TObject;
      const AProfileInfo: TTetheringProfileInfo);
  private
    FNumTracks: integer;
    FActualSong: string;
    FInfoTracks: TInfoTrackArray;
	  H: Thandle;
    Channel    : DWORD;
    APaused, ChangingPos:boolean;
    ChangingValuesFromMando:boolean;
    TSCanciones:TStringList;
    TipoConexion:integer;     // wifi=0   Bluetooth=1

    // Lista de canciones
    procedure SaveList;
    procedure RetrieveList;

    procedure _Log(AMsg:string);

    function ExtractSpecialChars(AStr:string):String;
    procedure TerminateSearch(Sender: TObject);
    procedure LBWindowProc(var Message: TMessage);
    procedure WMDROPFILES(var Msg: TMessage);

    procedure UpdateInfoCancion(ID:integer);
    procedure AddFile(AFileName:String);
    procedure SetActualSong(const Value: string);
    // Comprueba si hay cancion disponible
    function TestSong():boolean;
    // Recuperar informacin de la cancin.
  	procedure RetrieveInfoCancion(AActualSong:string);
    function GetIndexGrid(ASongFile:string):integer;
    procedure UpdateInfo(const Value: string);

    // actualizar los recursos locales
    procedure UpdateLocalResources(ID:Integer);
    procedure SendImageStream(IDRec:integer);

    // Atributos de la cancin
    function GetLong(Channel:DWORD):Double;
    function GetPos(Channel:DWORD):Double;
    function SetPos(Channel:DWORD; PosSeconds:Integer):boolean;

    // Devuelve si hay alguien conectado
    function AppConectada():boolean;

  public
    property numTracks:integer read FNumTracks write FNumTracks;
    property ActualSong:string read FActualSong write SetActualSong;
    property InfoTracks:TInfoTrackArray read FInfoTracks write FInfoTracks;
  end;


var
  FormMain: TFormMain;
  OldLBWindowProc: TWndMethod;


implementation

{$R *.dfm}

uses
  ShellAPI, Math, StrUtils, FMX.Styles, FMX.Types, Vcl.Themes, Vcl.Styles;


function TStringGrid.BackgroundVisible(var ClipRect: TRect): Boolean;
var
  Info: TGridDrawInfo;
  R: TRect;
begin
  CalcDrawInfo(Info);
  SetRect(ClipRect, 0, 0, Info.Horz.GridBoundary, Info.Vert.GridBoundary);
  R := ClientRect;
  Result := (ClipRect.Right < R.Right) or (ClipRect.Bottom < R.Bottom);
end;

procedure TStringGrid.Paint;
begin
  inherited Paint;
  PaintBackground;
end;

procedure TStringGrid.PaintBackground();
var
  R: TRect;
begin
  if (FGraphic <> nil) and BackgroundVisible(R) then
  begin
    with R do
      ExcludeClipRect(Canvas.Handle, Left, Top, Right, Bottom);
    if FStretched then
      Canvas.StretchDraw(ClientRect, FGraphic)
    else
      Canvas.Draw((R.Right - FGraphic.Width)div 2, (R.Bottom div 2), FGraphic);
  end;
end;

procedure TStringGrid.Resize;
begin
  inherited Resize;
  PaintBackground;
end;

procedure TStringGrid.TopLeftChanged;
begin
  inherited TopLeftChanged;
  PaintBackground;
end;

procedure TFormMain.FormResize(Sender: TObject);
begin
  // Tamao de las columnas
  sgCanciones.ColWidths[0] := 350;
  sgCanciones.ColWidths[1] := 100;
  sgCanciones.ColWidths[2] := sgCanciones.Width -
  sgCanciones.ColWidths[0] - sgCanciones.ColWidths[1] - 10;
  // Path completo; Oculta
  sgCanciones.ColWidths[3] := 0;
end;

procedure TFormMain.FormShow(Sender: TObject);
var
  res:integer;
  procINI: procedure(AppHandle:HWND; AWidth, AHeight:integer);
  AClass: TPersistentClass;
  procGetV: function():integer;
begin
  // No existe?
  if (not FileExists('PBass.BPL')) then begin
    H := 0;
    exit;
  end;

  H := LoadPackage('PBass.BPL');
  // Cargado correctamente?
  if (H > 0) then begin
    procINI := nil;
    @procINI := GetProcAddress(H, 'Start_INI');

    // Asignada?
    if Assigned(procINI) then begin
      // llamada
      procINI(Application.Handle, PaintFrame.Width, PaintFrame.Height);
    end;
  end
  else begin
    MessageDlg('Error, no se ha encontrado PBass.BPL', mtError, [mbOk], 0);
    Exit;
  end;

  // Recuperar el volumen
	procGetV := nil;
  @procGetV := GetProcAddress(H, 'GetVolume');
  // Asignada?
  if Assigned(procGetV) then begin
    // llamada
    tbVolumen.Position := procGetV;
    lblVolumen.Caption := Format('Volumen: %d' + '%',[tbVolumen.Position]);
  end;

  // recuperra la lista
  RetrieveList;
end;

procedure TFormMain.FormCreate(Sender: TObject);
var
  Vol: DWORD;
begin
  // ini
  OldLBWindowProc := sgCanciones.WindowProc; // store defualt WindowProc
  sgCanciones.WindowProc := LBWindowProc; // replace default WindowProc
  DragAcceptFiles(sgCanciones.Handle, True); // now ListBox1 accept dropped files
  // Otros
  Self.FNumTracks := 0;
  Self.FActualSong := '';

  //tsReproductor.TabVisible := False;
  //tsLog.TabVisible := False;

  // Volumen
  tbVolumen.Max := MAX_VOL_GENERIC;

  // Imagen de fondo
  sgCanciones.BackgroundGraphic := imgBack.Picture.Graphic;
  sgCanciones.BackgroundStretched := False;

end;

procedure TFormMain.LBWindowProc(var Message: TMessage);
begin
  if Message.Msg = WM_DROPFILES then
    WMDROPFILES(Message); // handle WM_DROPFILES message
  OldLBWindowProc(Message);
end;

procedure TFormMain.WMDROPFILES(var Msg: TMessage);
var
  pcFileName: PChar;
  i, iSize, iFileCount: integer;
begin
    pcFileName := ''; // to avoid compiler warning message
  iFileCount := DragQueryFile(Msg.wParam, $FFFFFFFF, pcFileName, 255);
  for i := 0 to iFileCount - 1 do  begin
    iSize := DragQueryFile(Msg.wParam, i, nil, 0) + 1;
    pcFileName := StrAlloc(iSize);
    DragQueryFile(Msg.wParam, i, pcFileName, iSize);
    if FileExists(pcFileName) then begin
      AddFile(pcFileName); // method to add each file
    end;
    StrDispose(pcFileName);
  end;
  DragFinish(Msg.wParam);

end;

procedure TFormMain._Log(AMsg: string);
begin
  mmLog.Lines.Add(AMsg);
//  ShowMessage('REPRODUCTOR: ' + AMsg);
end;

procedure TFormMain.ActionAdelanteExecute(Sender: TObject);
var
  i:integer;
begin
	if not TestSong() then Exit;

  // Buscamos el siguiente de la lista y doble click
  APaused := False;
  i := sgCanciones.Row;
  if (i >= sgCanciones.RowCount - 1) then begin
    sgCanciones.Row := 0;
  end
  else begin
    sgCanciones.Row := sgCanciones.Row + 1;
  end;
  // Simular dblClick
  sgCancionesDblClick(nil);

end;

procedure TFormMain.ActionatrasExecute(Sender: TObject);
var
  i:integer;
begin
	if not TestSong() then Exit;

  // Buscamos el siguiente de la lista y doble click
  APaused := False;
  i := sgCanciones.Row;
  if (i = 0) then begin
    sgCanciones.Row := (sgCanciones.RowCount - 1);
  end
  else begin
    sgCanciones.Row := sgCanciones.Row - 1;
  end;
  // Simular dblClick
  sgCancionesDblClick(nil);
end;

procedure TFormMain.ActionPauseExecute(Sender: TObject);
var
  procPause: function(Channel:DWORD):boolean;
  b:Boolean;
begin
  if not TestSong() then Exit;

  // Preparar la ejecucin
  APaused := True;
	procPause := nil;
  @procPause := GetProcAddress(H, 'Pause');
  // Asignada?
  if Assigned(procPause) then begin
    // llamada
    b := procPause(Channel);
  end;
  TimerMarquee.Enabled := False;
end;

procedure TFormMain.ActionPlayExecute(Sender: TObject);
var
  fName:AnsiString;
  procPlay: function (FName:PChar; APaused:boolean):DWord;
begin
  if not TestSong() then Exit;

  // Si est funcionando la paramos
  ActionStop.Execute;

  // Recuperar la seleccionada en el Grid
  Self.FActualSong := sgCanciones.Cells[3, sgCanciones.Row];
  fName := ActualSong;

  APaused := False;
  // reparar la ejecucin
	procPlay := nil;
  @procPlay := GetProcAddress(H, 'Play');
  // Asignada?
  if Assigned(procPlay) then begin
    // llamada
    Channel := procPlay(PChar(fName), APaused);
  end;

  // Activar el timer de visualizacion
  TimerPack.Enabled := True;
  TimerMarquee.Enabled := True;

  // actualizar informacin
  UpdateInfo(Self.FActualSong);

end;

procedure TFormMain.ActionSendInfoToRemoteExecute(Sender: TObject);
var
  i:integer;
begin
  // enviarle la informacin
  i := GetIndexGrid(ActualSong);
  UpdateLocalResources(i);
end;

procedure TFormMain.ActionStopExecute(Sender: TObject);
var
  procStop: function (Channel:DWORD):boolean;
  b:Boolean;
begin
  if not TestSong() then Exit;

  // Preparar la ejecucin
  APaused := False;
	procStop := nil;
  @procStop := GetProcAddress(H, 'Stop');
  // Asignada?
  if Assigned(procStop) then begin
    // llamada
    b := procStop(Channel);
  end;
  TimerMarquee.Enabled := False;
end;

procedure TFormMain.AddFile(AFileName: String);
var
  str:string;
begin

  Str := ChangeFileExt(ExtractFileName(AFileName), '');
  sgCanciones.Cells[0, Self.numTracks] := str;

  sgCanciones.Cells[3, Self.numTracks] := AFileName;
  Inc(Self.FnumTracks);

  sgCanciones.RowCount := Max(numTracks, 1);

  if (sgCanciones.RowCount > 1) then begin
	  sgCanciones.FGraphic := nil;
  end
  else begin
		sgCanciones.BackgroundGraphic := imgBack.Picture.Graphic;
  end;
  Invalidate;

  // Incremenamos el array de canciones
  SetLength(Self.FInfoTracks, sgCanciones.RowCount);

end;

// Devuelve si hay alguien conectado
function TFormMain.AppConectada(): boolean;
begin
  Result := (ttProfiler.ConnectedProfiles.Count > 0);

  // Actualizamos la Imagen
  if (Result) then begin
    // Conectado
    sbMandoConectado.Glyph.Assign(imgControlAzul.Picture.Bitmap);
  end
  else begin
    sbMandoConectado.Glyph.Assign(imgcontrolBlanco.Picture.Bitmap);
  end;
end;

procedure TFormMain.Button1Click(Sender: TObject);
begin
  TStyleManager.TrySetStyle('Metropolis UI Black');
end;

procedure TFormMain.Button2Click(Sender: TObject);
begin
  TStyleManager.TrySetStyle('Metropolis UI Blue');
end;

procedure TFormMain.Button3Click(Sender: TObject);
begin
  TStyleManager.TrySetStyle('Metropolis UI Green');
end;

procedure TFormMain.sgCancionesDblClick(Sender: TObject);
begin
  // actualizar la cancin actual
  Self.ActualSong := sgCanciones.Cells[3, sgCanciones.Row];
end;


procedure TFormMain.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  TStyleManager.TrySetStyle('Metropolis UI Green');
  ttManager.AllowedAdapters := 'Network';
end;

procedure TFormMain.Shape2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  TStyleManager.TrySetStyle('Metropolis UI Black');
  ttManager.AllowedAdapters := 'Network';
end;

procedure TFormMain.Shape3ContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
  TStyleManager.TrySetStyle('Metropolis UI Green');
end;

procedure TFormMain.Shape3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  TStyleManager.TrySetStyle('Metropolis UI Blue');
  ttManager.AllowedAdapters := 'Bluetooth';
end;

procedure TFormMain.SetActualSong(const Value: string);
var
  str:string;
begin
  Self.FActualSong := Value;

  // cancion (label)
  Str := ExtractFileName(Value);
  Str := ChangeFileExt(sTR, '');
  lblReproduciendo.Caption := sTR;

  // Asignar al reproductor
  ActionStop.Execute;
  ActionPlay.Execute;

  // Hay alguien conectado?
  if AppConectada then begin
    // Lista de canciones
    ttProfiler.Resources.FindByName('ListaCanciones').Value := TSCanciones.Text;
  end;

end;

procedure TFormMain.UpdateInfo(const Value: string);
var
  i, min, sec:Integer;
  d:Double;
begin
  // Duracion de la cancin
  d := GetLong(Channel);
  min := Trunc(d) div 60;
  sec := Trunc(d) mod 60;
  lblDuracion.Caption := Format('%.2d:%.2d',[min, sec]);
  tbCancion.Max := trunc(d);

  // Hay alguna app. conectada?
  if AppConectada then begin
    // Actualizar los recursos
    ttProfiler.Resources.FindByName('rTiempoTotal').Value := lblDuracion.Caption;
    ttProfiler.Resources.FindByName('rMaxCancion').Value := IntToStr(tbCancion.Max);
    ttProfiler.Resources.FindByName('rTiempoCancion').Value := lblPosition.Caption;
    ttProfiler.Resources.FindByName('rPosCancion').Value := IntToStr(tbCancion.Position);
    ttProfiler.Resources.FindByName('rMaxCancion').Value := IntToStr(tbCancion.Max);

    // Aprovachamos para enviar el resto de info
    ActionSendInfoToRemoteExecute(nil);

  end;

  // LOG ====================================
{
  Memo1.Lines.Clear;
  Memo1.Lines.Add('Frames: ' + IntToStr(mp3player.Frames));
  Memo1.Lines.Add('TrackLength[0]: ' + IntToStr(mp3player.TrackLength[0]));
  Memo1.Lines.Add('TrackLength[1]: ' + IntToStr(mp3player.TrackLength[1]));
  Memo1.Lines.Add('Tracks: ' + IntToStr(mp3player.Tracks));
}
  // ========================================

  i := GetIndexGrid(Value);
  // Ya se ha buscado la info anteriormente?
  if (InfoTracks[i].Anyo <> -999) and (InfoTracks[i].Anyo = 0) then begin
    // Recuperar informacin de la cancin.
    RetrieveInfoCancion(Self.FActualSong);
  end;

  // Ya la tenemos
  if (InfoTracks[i].Anyo <> -999) and (InfoTracks[i].Anyo <> 0) then begin
    UpdateInfoCancion(i);
  end;
end;

procedure TFormMain.ProgresTimerTimer(Sender: TObject);
var
  wLen:Cardinal;
  d:Double;
  min, sec:Integer;
  b:Boolean;
begin

	ChangingPos := True;
  try
    if (Channel = 0) then Exit;

    // Longitud de la cancion
    d := GetPos(Channel);
    min := Trunc(d) div 60;
    sec := Trunc(d) mod 60;

    lblPosition.Caption := Format('%.2d:%.2d',[min, sec]);
    tbCancion.Position := trunc(d);

    if (ttProfiler.ConnectedProfiles.Count > 0) then begin
      // Recurso
      ttProfiler.Resources.FindByName('rTiempoCancion').Value := lblPosition.Caption;

      if (not ChangingValuesFromMando) then begin
        ttProfiler.Resources.FindByName('rPosCancion').Value := IntToStr(tbCancion.Position);
      end;

      ttProfiler.Resources.FindByName('rMaxCancion').Value := IntToStr(tbCancion.Max);
//      ttProfiler.Resources.FindByName('rVolumen').Value := IntToStr(tbVolumen.Position);
    end;

    // ShowMessage('Voluman: ' + IntToStr(tbVolumen.Position));

	finally
  	ChangingPos := False;
  end;

  // Actualizar imagen
  AppConectada();

end;

procedure TFormMain.tbCancionChange(Sender: TObject);
var
  b:Boolean;
begin
	if ChangingPos then Exit;
  // modificar la posicion
	b := SetPos(Channel, tbCancion.Position);

end;

procedure TFormMain.tbVolumenChange(Sender: TObject);
var
  procSetV: function(NewVol:integer):Boolean;
  b:boolean;
begin

  // volumen
	procSetV := nil;
  @procSetV := GetProcAddress(H, 'SetVolume');
  // Asignada?
  if Assigned(procSetV) then begin
    // llamada
    b := procSetV(tbVolumen.Position);
  end;

  // MPSetVolume(mp3player, TrackBar2.Position);
  lblVolumen.Caption := Format('Volumen: %d' + '%',[tbVolumen.Position]);

  // Slo lo enviamos si no lo ha cambiado el Mando
  if (not ChangingValuesFromMando) then begin
    // Recurso Local
    ttProfiler.Resources.FindByName('rVolumen').Value := IntToStr(tbVolumen.Position);
  end;
end;


procedure TFormMain.FormDestroy(Sender: TObject);
begin

  // Para la reproduccion
  ActionStop.Execute;

  if (H <> 0) then begin
    try
      // descargar el package
   //--Debug   UnloadPackage(H);
    except
      // Error al descargar package
    end;
  end;

  // desactivar los componentes de conexion
  ttProfiler.Enabled := False;
  ttManager.Enabled := False;

  // Grabar la lista
  SaveList;



end;

// Comprueba si hay cancion disponible
function TFormMain.TestSong(): boolean;
var
  str:string;
begin

	Result := False;
	// No hay seleccionada
  if (Self.FActualSong = '') then begin
		// Hay algo en el Grid?
    Str := sgCanciones.Cells[3, sgCanciones.Row];
    // Existe?
    if FileExists(Str) then begin
	    Self.FActualSong := Str;
      Result := True;
    end;
  end
  else begin
	  // Existe?
  	Result := FileExists(FActualSong);
  end;
end;

procedure TFormMain.TimerPackTimer(Sender: TObject);
var
	procDraw:procedure (Channel:DWORD; AHandle:HWND; AWidth, AHeight:integer);
begin

	procDraw := nil;
  @procDraw := GetProcAddress(H, 'Draw');

  // Asignada?
  if Assigned(procDraw) then begin
    // llamada
    procDraw(Channel, PaintFrame.Canvas.Handle, PaintFrame.Width, PaintFrame.Height);
  end;
end;


procedure TFormMain.ttManagerEndAutoConnect(Sender: TObject);
begin
  _Log('End Autoconnect; ');
end;

procedure TFormMain.ttManagerEndManagersDiscovery(const Sender: TObject;
  const ARemoteManagers: TTetheringManagerInfoList);
begin
  _Log('End Managers discover; ' + 'Encontrados: ' + IntToStr(ARemoteManagers.Count));
end;

procedure TFormMain.ttManagerEndProfilesDiscovery(const Sender: TObject;
  const ARemoteProfiles: TTetheringProfileInfoList);
var
  i:integer;
  pInfo:TTetheringProfileInfo;
  rRes:TRemoteResource;
  b:boolean;
begin

  // Suscribirse a los recursos del mando
  i := ttManager.RemoteProfiles.Count;
  i := ARemoteProfiles.Count;
  _Log('Encontrados profiles: ' + IntToStr(i));

  // Hay alguno?
  if (i > 0) then begin
    pInfo := ttManager.RemoteProfiles[0];
    pInfo := ARemoteProfiles[0];

    b := ttProfiler.Connect(pInfo);
    if (b) then begin
      _Log('Connected');
    end;

    _Log('Profile[0]: ' + pInfo.ProfileIdentifier);
    _Log('Profile[0]: ' + pInfo.ProfileText);

    // Suscribirse a los recursos remotos
    b := ttProfiler.SubscribeToRemoteItem(ARemoteProfiles[0], 'MasterVolume');
    b := ttProfiler.SubscribeToRemoteItem(ARemoteProfiles[0], 'PosicionCancion');
  end;


end;

procedure TFormMain.ttManagerNewManager(const Sender: TObject;
  const AManagerInfo: TTetheringManagerInfo);
begin
  // Autoconectar
  _Log('New Manager; ' + AManagerInfo.ManagerText);
  //--ttManager.AutoConnect();
end;

procedure TFormMain.ttManagerPairedFromLocal(const Sender: TObject;
  const AManagerInfo: TTetheringManagerInfo);
var
  i:integer;
  pInfo:TTetheringProfileInfo;
begin
  _Log('PairedFromLocal -> ' + AManagerInfo.ManagerName);

  i := ttManager.RemoteManagers.Count;
  _log('Managers remotos: ' + IntToStr(i));
  i := ttManager.RemoteProfiles.count;
  _log('Profiles remotos: ' + IntToStr(i));

  ttManager.PairManager(AManagerInfo);

  // Conectado
  sbMandoConectado.Glyph.Assign(imgControlAzul.Picture.Bitmap);

  // Desactivar el botn de cambio
//--  sbTipoConexion.Enabled := False;

end;

procedure TFormMain.ttManagerPairedToRemote(const Sender: TObject;
  const AManagerInfo: TTetheringManagerInfo);
begin
  _Log('PairedToremote');

end;

procedure TFormMain.ttManagerUnPairManager(const Sender: TObject;
  const AManagerInfo: TTetheringManagerInfo);
begin

  // Desconectado? Actualizar imagen
  AppConectada();

end;

procedure TFormMain.ttProfilerAcceptResource(const Sender: TObject;
  const AProfileId: string; const AResource: TCustomRemoteItem;
  var AcceptResource: Boolean);
begin
  AcceptResource := True;
end;

procedure TFormMain.ttProfilerDisconnect(const Sender: TObject;
  const AProfileInfo: TTetheringProfileInfo);
begin
  // Desconectado? Actualizar imagen
  AppConectada();

end;

procedure TFormMain.ttProfilerResourceReceived(const Sender: TObject;
  const AResource: TRemoteResource);
begin
  {
  _Log('Resource received; ' + AResource.Name);
  _Log('Hint= ' + AResource.Hint);
  _Log('Valor= ' + AResource.Value.AsString);
  }

  // Segun el recurso hacemos cosas...

end;

procedure TFormMain.ttProfilerResourceUpdated(const Sender: TObject;
  const AResource: TRemoteResource);
begin
  // Volumen
  if (AResource.Name = 'MasterVolume') then begin
    try
      ChangingValuesFromMando := True;
      tbVolumen.Position := StrToIntDef(AResource.Value.AsString, 0);
    finally
      ChangingValuesFromMando := False;
    end;
  end;

  if (AResource.Name = 'PosicionCancion') then begin
    try
      ChangingValuesFromMando := True;
      tbCancion.Position := StrToIntDef(AResource.Value.AsString, 0);
      _log('MANDO -> Posicion: ' + IntToStr(tbCancion.Position));
    finally
      ChangingValuesFromMando := False;
    end;
  end


end;

// Recuperar informacin de la cancin.
procedure TFormMain.RetrieveInfoCancion(AActualSong: string);
var
  th:TInfoTrackThread;
  Str:string;
  i:Integer;
begin
  // Obtener la info del Ttulo (tambin se podra hacer del ID3Tag)
  Str := ExtractFileName(ActualSong);
  Str := ChangeFileExt(Str, '');
  Str := ExtractSpecialChars(Str);
  // Obtener el ndice
  i := GetIndexGrid(ActualSong);
  // No encontrado?
  if (i = -1) then Exit;

  // Crear el thread de bsqueda
  th := TInfoTrackThread.Create(i, Str, ''{edtArtista.Text, edtCancion.Text});
  th.NumResults := 1;
  // ini
  th.FreeOnTerminate := True;
  th.OnTerminate := TerminateSearch;
  // ejecutar
  th.Resume;
end;

procedure TFormMain.SaveList;
var
  TS:TStrings;
  i:integer;
  fName, Str:String;
begin

  TS := TStringList.Create;
  try
    for i := 0 to (sgCanciones.RowCount - 1) do begin
      Str := sgCanciones.Cells[3, i];
      if FileExists(Str) then begin
        TS.Add(Str);
      end;
    end;

    fName := ExtractFilePath(Application.ExeName) + 'TrackList.txt';
    TS.SaveToFile(fName);

  finally
    FreeAndnil(TS);
  end;
end;


procedure TFormMain.sbTipoConexionClick(Sender: TObject);
begin

{
  // Alguien conectado?  => salimos
  if AppConectada then Exit;


  // Cambiar el AppManager
  ttManager.Enabled := False;

  // Cambiar
  if (TipoConexion = 0) then begin  //WIFI
    TipoConexion := 1;
    sbTipoConexion.Glyph.Assign(imgBlutooth20.Picture.Bitmap);
    ttManager.AllowedAdapters := 'Bluetooth';
  end
  else begin                      //bluetooth
    TipoConexion := 0;
    sbTipoConexion.Glyph.Assign(imgWifi20.Picture.Bitmap);
    ttManager.AllowedAdapters := 'Network';
  end;

  // Reactivarlo
  ttManager.Enabled := True;
}

end;

procedure TFormMain.RetrieveList;
var
  i:integer;
  fName, Str:String;
begin

  fName := ExtractFilePath(Application.ExeName) + 'TrackList.txt';
  // no existe
  if not FileExists(fName) then Exit;

  // Cargamos la lista
  if not Assigned(TSCanciones) then begin
    TSCanciones := TStringList.Create;
  end;
  TSCanciones.Clear;

  try
    TSCanciones.LoadFromFile(fName);

    for i := 0 to (TSCanciones.Count - 1) do begin
      if FileExists(TSCanciones[i]) then begin
        AddFile(TSCanciones[i]);

        // Cambiarlo
        TSCanciones[i] := ChangeFileExt(TSCanciones[i], '');
        TSCanciones[i] := ExtractFileName(TSCanciones[i]);


      end;
    end;

  finally
    // Nada
  end;

  // Enviarla al recurso
  ttProfiler.Resources.FindByName('ListaCanciones').Value := TSCanciones.Text;

end;

procedure TFormMain.TerminateSearch(Sender: TObject);
var
  th:TInfoTrackThread;
  it:TInfoTrack;
  i:integer;
begin

  if (Sender is TInfoTrackThread) then begin
    th := TInfoTrackThread(Sender);

    // Hay algun resultado?
    if (Length(th.InfoArray) > 0) then begin
      // NOTA: Nos quedamos slo con el primer resultado
      it := th.InfoArray[0];

      // Acceder a los valores
      InfoTracks[it.ID].ArtistName := it.ArtistName;
      InfoTracks[it.ID].TrackName := it.TrackName;
      InfoTracks[it.ID].CollectionName := it.CollectionName;
      InfoTracks[it.ID].Genero := it.Genero;
      InfoTracks[it.ID].Anyo := it.Anyo;
      InfoTracks[it.ID].Imagen100 := it.Imagen100;
      InfoTracks[it.ID].PathImage := it.PathImage;

      // Actualizar en pantalla
      if (InfoTracks[it.ID].Anyo <> -999) and (InfoTracks[it.ID].Anyo <> 0) then begin
        UpdateInfoCancion(it.ID);
      end;
    end
    else begin
      // No encontrada
      InfoTracks[th.ID].Anyo := -999;
      pnlCamposInfo.Visible := False;
    end;

  end;
end;


function TFormMain.GetIndexGrid(ASongFile: string): integer;
var
  i:integer;
begin
  Result := -1;
  for i := 0 to (sgCanciones.RowCount - 1) do begin
    if (sgCanciones.Cells[3, i] = ASongFile) then begin
      Result := i;
      Break;
    end;
  end;
end;

function TFormMain.ExtractSpecialChars(AStr: string): String;
var
  i:integer;
  str:string;
begin
  Str := AStr;
  for i := 33 to 47 do begin
    Str := AnsiReplaceText(Str, Char(i), '');
  end;
  for i := 58 to 64 do begin
    Str := AnsiReplaceText(Str, Char(i), '');
  end;
  for i := 124 to 191 do begin
    Str := AnsiReplaceText(Str, Char(i), '');
  end;
  Result := str;

end;

procedure TFormMain.UpdateInfoCancion(ID:integer);
begin
  dbedtArtista.Text := InfoTracks[ID].ArtistName;
  dbedtAlbum.Text := InfoTracks[ID].CollectionName;
  dbedtCancion.Text := InfoTracks[ID].TrackName;
  dbedtGenero.Text := InfoTracks[ID].Genero;
  dbedtAnyo.Text := IntToStr(InfoTracks[ID].Anyo);
  dbimgCaratula.Picture.LoadFromFile(InfoTracks[ID].PathImage);
  pnlCamposInfo.Visible := true;

  // Actualizar los recursos compartidos
  UpdateLocalResources(ID);
end;

// enviar info de la caratula
procedure TFormMain.SendImageStream(IDRec:integer);
var
  pInfo:TTetheringProfileInfo;
  ts:TStream;
  CaractulaStream: TMemoryStream;
  JPEGImage: TJPEGImage;
begin
  // Acceder a la info. del perfil
  pInfo := ttManager.RemoteProfiles[0];

  JPEGImage := TJPEGImage.Create();
  CaractulaStream := TMemoryStream.Create;

  if FileExists(InfoTracks[IDRec].PathImage) then begin
    try
      JPEGImage.LoadFromFile(InfoTracks[IDRec].PathImage);
      JPEGImage.SaveToStream(CaractulaStream);
      ttProfiler.SendStream(pInfo, 'rCaratula', CaractulaStream);
    finally
      CaractulaStream.Free;
      JPEGImage.Free;
    end;
  end;
end;

// actualizar los recursos locales
procedure TFormMain.UpdateLocalResources(ID:Integer);
begin

  // actualizar los recursos compartidos
  ttProfiler.Resources.FindByName('rArtista').Value := dbedtArtista.Text;
  ttProfiler.Resources.FindByName('rAlbum').Value := dbedtAlbum.Text;
  ttProfiler.Resources.FindByName('rCancion').Value := dbedtCancion.Text;
  ttProfiler.Resources.FindByName('rGenero').Value := dbedtGenero.Text;
  ttProfiler.Resources.FindByName('rAnyo').Value := dbedtAnyo.Text;
  // Actualizar el volumen
  ttProfiler.Resources.FindByName('rVolumen').Value := IntToStr(tbVolumen.Position);
  // Lista de canciones
  ttProfiler.Resources.FindByName('ListaCanciones').Value := TSCanciones.Text;

  // Aplicacin conectada?
  if AppConectada then begin
    // enviar datos a los profiles remotos
    SendImageStream(ID);
  end;
end;

procedure TFormMain.TimerMarqueeTimer(Sender: TObject);
var
  txt : string;
begin
  txt := lblReproduciendo.Caption;

  if (True) {rgDirection.ItemIndex = 0} then begin   // IZQUIERDA
    lblReproduciendo.Caption :=
      Copy(txt, 2, Length(txt) - 1) + Copy(txt,1,1)
  end
  else begin  // DERECVA
    lblReproduciendo.Caption:=
      Copy(txt, Length(txt)-1,1) + Copy(txt, 1, Length(txt)-1) ;
  end;
end;

function TFormMain.GetPos(Channel:DWORD):Double;
var
  procPos: function (Channel:DWORD):double;
begin
	procPos := nil;
  @procPos := GetProcAddress(H, 'GetPosition');
  // Asignada?
  if Assigned(procPos) then begin
    // llamada
    Result := procPos(Channel);
  end;
end;


function TFormMain.GetLong(Channel: DWORD): double;
var
  procLen: function (Channel:DWORD):double;
begin
	procLen := nil;
  @procLen := GetProcAddress(H, 'GetLength');
  // Asignada?
  if Assigned(procLen) then begin
    // llamada
    Result := procLen(Channel);
  end;
end;

function TFormMain.SetPos(Channel: DWORD; PosSeconds: Integer): boolean;
var
  procPos: function (Channel:DWORD; NewPos:Int64):Boolean;
begin
	procPos := nil;
  @procPos := GetProcAddress(H, 'SetPosition');
  // Asignada?
  if Assigned(procPos) then begin
    // llamada
    Result := procPos(Channel, PosSeconds);
  end;

end;

end.
